<?php
//------------------------------------------------------------------------------
// SimpleChat v2.1.1 [10.01.2014]
// Simple chat for phpBB 3 (inspired by delphimaster.ru)
// Copyright 2008-2013 Evgeny Vrublevsky <veg@tut.by> http://vrublevsky.org/
//------------------------------------------------------------------------------

define("IN_PHPBB", true);
$phpbb_root_path = './../';
$phpbb_chat_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
header("cache-control: no-cache, must-revalidate");

// Init
$user->session_begin();
$auth->acl($user->data);
$user->setup();
$user->set_custom_lang_path($phpbb_chat_path.'language');
$user->add_lang('chat');
$user->set_custom_lang_path($phpbb_root_path . 'language'); // Required for some MODs

// Define tables
define('CHAT_MESSAGES_TABLE',	$table_prefix . 'chat_messages');
define('CHAT_SESSIONS_TABLE',	$table_prefix . 'chat_sessions');

// Settings
define('SESSION_LIFE',			180);			// Session lifetime
define('MESSAGES_LIMIT',		100);			// Store messages limit
define('JOIN_MESSAGES',			true);			// Display join messages
define('LEFT_MESSAGES',			true);			// Display left messages
define('ANTIFLOOD_SENSITIVITY',	9);				// Antiflood sensitivity (less is more sensitive)
define('ANTIFLOOD_EXTINCTION',	3);				// Antiflood extinction (less is faster)
define('ANTIFLOOD_DURATION',	30);			// Antiflood ban duration in seconds
define('BUILD_TIME', filemtime(__FILE__));		// Internal version

// Statuses (currently unused)
define('STATUS_ONLINE',	0); // Online
define('STATUS_CHAT',	1); // Chat with me!
define('STATUS_AWAY',	2); // Away
define('STATUS_DND',	3); // Do not disturb

// Actions
define('ACT_LOAD', 	'load');
define('ACT_SYNC', 	'sync');
define('ACT_SAY',	'say');

// Special messages
define('MSG_JOIN',	'/hello');
define('MSG_LEFT',	'/bye');

$action = request_var('action', ACT_LOAD);
header('content-type: text/' . (($action == ACT_LOAD)?'html':'javascript') . '; charset=UTF-8');

// Check internal version
if($action != ACT_LOAD && request_var('build', BUILD_TIME) != BUILD_TIME)
{
	echo('FullReset();');
	exit;
}

// Auth check
if (!$user->data['is_registered'])
{
	if ($action!=ACT_LOAD)
	{
		echo('FullReset();');
	}
	else
	{
		$template->assign_var('COPYRIGHT', $user->lang['POWERED_BY']);
		login_box($phpbb_chat_path . 'chat/index.php', $user->lang['LOGIN_EXPLAIN_CHAT']);
	}
	exit;
}

/*
// Ban check (unused)
if($chat_session['user_status']==STATUS_BANNED)
{
	if($action!=ACT_LOAD) echo('FullReset();');
	else trigger_error($user->lang['CHAT_BANNED']);
	exit;
}
*/

// Detect left users
$die_time = time() - SESSION_LIFE;

if (LEFT_MESSAGES)
{
	$sql = "SELECT *
		FROM " . CHAT_SESSIONS_TABLE . "
		WHERE last_active < '{$die_time}'
		ORDER BY last_active";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		// Add message that user is left
		$message = array(
			'user_id'	=> $row['user_id'],
			'username'	=> $row['username'],
			'time'		=> $row['last_active'] + SESSION_LIFE,
			'text'		=> MSG_LEFT,
			'color'		=> '000000'
		);
		$sql = "INSERT INTO " . CHAT_MESSAGES_TABLE . " " . $db->sql_build_array('INSERT', $message);
		$db->sql_query($sql);
	}
}

// Remove left users
$sql = "DELETE
	FROM " . CHAT_SESSIONS_TABLE . "
	WHERE last_active < '{$die_time}'";
$db->sql_query($sql);

// Create new or prolong old session
$sql = 'SELECT *
	FROM ' . CHAT_SESSIONS_TABLE . '
	WHERE user_id = ' . (int)$user->data['user_id'];
$result = $db->sql_query($sql);
$chat_session = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
if(!$chat_session)
{
	// Add new user if needed
	$chat_session = array(
		'user_id'		=> $user->data['user_id'],
		'username'		=> $user->data['username'],
		'last_active'	=> time(), // if user is banned - time to unban, time of the last message if else
		'user_status'	=> STATUS_ONLINE,
		'user_activity'	=> 0,
		'user_blocked'	=> 0
	);
	$sql = 'INSERT INTO ' . CHAT_SESSIONS_TABLE . ' ' .	$db->sql_build_array('INSERT', $chat_session);
	$db->sql_query($sql);

	if (JOIN_MESSAGES)
	{
		// Add message that new user is joined
		$message = array(
			'user_id'	=> $user->data['user_id'],
			'username'	=> $user->data['username'],
			'time'		=> time(),
			'text'		=> MSG_JOIN,
			'color'		=> '000000'
		);
		$sql = "INSERT INTO " . CHAT_MESSAGES_TABLE . " " . $db->sql_build_array('INSERT', $message);
		$db->sql_query($sql);
	}
}
else
{
	// Update user activity time and antiflood ban necessity detection
	$chat_session['user_activity'] -= time() - $chat_session['last_active'];
	if($chat_session['user_activity'] < 0) $chat_session['user_activity'] = 0;
	if(!$chat_session['user_blocked'] && $action == ACT_SAY)
	{
		$chat_session['user_activity'] += ANTIFLOOD_EXTINCTION;
		if($chat_session['user_activity'] > ANTIFLOOD_SENSITIVITY)
		{
			$chat_session['user_activity'] = ANTIFLOOD_DURATION;
			$chat_session['user_blocked'] = 1;
		}
	}
	if($chat_session['user_activity'] == 0)
	{
		$chat_session['user_blocked'] = 0;
	}
	$chat_session['last_active'] = time();
	$sql = 'UPDATE ' . CHAT_SESSIONS_TABLE . '
		SET ' . $db->sql_build_array('UPDATE', $chat_session) . '
		WHERE user_id = ' . $user->data['user_id'];
	$db->sql_query($sql);
}

// Handle commands
switch ($action)
{
	// Load chat body
	case ACT_LOAD:
		include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
		page_header($user->lang['CHAT']);
		//$template->set_custom_template($phpbb_chat_path.'template', 'simplechat');
		$template->set_custom_style('simplechat', $phpbb_chat_path.'template');
		$template->set_filenames(array('body' => 'chat_body.html'));
		$template->assign_vars(array(
			'COPYRIGHT' 	=> $user->lang['POWERED_BY'],
			'BUILD_TIME' 	=> BUILD_TIME
		));
		generate_smilies("inline", false);
		page_footer();
	exit;

	// Add new message
	case ACT_SAY:
		if($chat_session['user_blocked'])
		{
			$time = date("H:i", time());
			$name = "";
			$text = sprintf($user->lang['CHAT_BLOCKED'], $chat_session['user_activity']);
			echo("LogMessage(0,'$time','$name','$text','000000');\n");
			exit;
		}
		$text = trim(utf8_normalize_nfc(request_var('text', '', true)));

		/*
		// Words longer than 70 symbols are not allowed
		$data = explode(' ', $text);
		$text = "";
		foreach($data as $word)
		{
			if(utf8_strlen($word) > 70) $word = utf8_substr($word, 0, 70);
			$text .= $word . " ";
		}
		$text = trim($text);
		*/

		// Messages longer than 255 symbols are not allowed
		if(utf8_strlen($text) > 255) $text = utf8_substr($text, 0, 255);
		$color	= request_var('color', '000000');
		if (!preg_match('#^[0-9a-f]{6}$#', $color)) $color = '000000';
		if($text!='')
		{
			$message = array(
				'user_id'	=> $user->data['user_id'],
				'username'	=> $user->data['username'],
				'time'		=> time(),
				'text'		=> $text,
				'color'		=> $color
			);
			$sql = "INSERT INTO " . CHAT_MESSAGES_TABLE . " " . $db->sql_build_array('INSERT', $message);
			$db->sql_query($sql);
		}
	exit;

	// Chat sync
	case ACT_SYNC:
		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		// Users list
		$sql = "SELECT user_id as id, username as name, user_status as status FROM " . CHAT_SESSIONS_TABLE; // . " WHERE status != " . STATUS_HIDDEN;
		$json = json_encode($db->sql_fetchrowset($db->sql_query($sql)));
		echo("SetUsers($json);\n");

		// Output new messages
		$last_id = request_var('lastid', 0);
		$sql = "SELECT *
			FROM " . CHAT_MESSAGES_TABLE . "
			WHERE msg_id > " . $last_id . "
			ORDER BY msg_id";
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			if($row['msg_id'] > $last_id) $last_id = $row['msg_id'];
			$msg_id = $row['msg_id'];
			$username = addslashes($row['username']);
			$user_id = $row['user_id'];
			$color = addslashes($row['color']);
			$time = addslashes($user->format_date($row['time'], "H:i", true));

			$text = trim($row['text']);
			if($text == MSG_JOIN)
			{
				echo("LogUserJoin($msg_id, '$time', '$username');\n");
				continue;
			}
			if($text == MSG_LEFT)
			{
				echo("LogUserLeft($msg_id, '$time', '$username');\n");
				continue;
			}

			// Handle private messages
			$show = true;
			if( utf8_substr($text, 0, utf8_strlen("private ["))=="private [" )
			{
				$show = false;
				$tmp = $text;
				while(utf8_strpos($tmp, "private [")===0)
				{
					$endp = utf8_strpos($tmp, "]");
					$to = str_replace("private [", "", utf8_substr($tmp, 0, $endp));
					if($to == $user->data['username']) $show = true;
					$tmp = trim(utf8_substr($tmp, $endp+1));
				}
				$msgpriv = trim(utf8_substr($text, 0, utf8_strlen($text)-utf8_strlen($tmp)));
				$text = "<span class=\"private\">" . $msgpriv . "</span> " . $tmp;
			}
			if((!$show) && ($user->data['username'] != $row['username']) ) continue;

			// Parse smilies and links in the message
			if(utf8_strlen($text)>1)
			{
				$message_parser = new parse_message($text);
				$message_parser->magic_url(false);
				$message_parser->smilies(0);
				$text = (string) $message_parser->message;
				unset($message_parser);
				$text = str_replace("<a ", "<a target='_blank' ", $text);
				$text = str_replace("{SMILIES_PATH}", "{$phpbb_root_path}{$config['smilies_path']}", $text);
			}
			$text = str_replace("to [".$user->data['username']."]", "<span class=\"to\">to [".$user->data['username']."]</span>", $text);
			$text = addslashes(str_replace(array("\r", "\n"), ' ', $text));
			echo("LogMessage($msg_id, '$time', '$username', '$text', '$color');\n");
		}
		echo("SetLastId($last_id);\n");

		// Delete obsolete messages
		$sql = "DELETE FROM " . CHAT_MESSAGES_TABLE . " WHERE msg_id < " . ($last_id - MESSAGES_LIMIT);
		$db->sql_query($sql);
	exit;
}
