<?php
/**
 *
 * Simple Chat Extension
 *
 * @copyright (c) 2015 Anvar <http://bb3.mobi>
 * @license  GNU General Public License 2
 *
 */
namespace Sumanai\simplechat\event;

class listener implements \Symfony\Component\EventDispatcher\EventSubscriberInterface
{

	/** @var \phpbb\user */
	private $user;

	/** @var \phpbb\template\template */
	protected $template;

	/**
	 * @param \phpbb\user $user
	 */
	public function __construct(\phpbb\user $user, \phpbb\template\template $template)
	{
		$this->user = $user;
		$this->template = $template;
	}

	static public function getSubscribedEvents()
	{
		return array(
			'core.page_header_after' => 'page_header_after',
		);
	}

	public function page_header_after()
	{
		$this->user->add_lang_ext("Sumanai/simplechat", "simple_chat");

		$this->template->assign_vars(
			array(
				'U_SIMPLE_CHAT'	=> generate_board_url() . '/chat',
				'L_SIMPLE_CHAT'	=> $this->user->lang['SIMPLE_CHAT'],
			)
		);
	}
}
